{Sloka mladez mus bt umstna ve stejnm adresi jako tento program!}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, xmldom, XMLIntf, msxmldom, XMLDoc;




type

  TNota = record
            delka : byte;
            vyska : string[3];

          end;


  TSkladba = record
               takt : byte;
               noty : array of Tnota;

             end;
  TObrazky = array[1..22] of TBitmap;



  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    XMLDocument1: TXMLDocument;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Aktivace;
    procedure NactiSkladbu(adresa : string; var s : TSkladba);
    procedure UpravaXY(var x, y : integer; typ : string; delka : byte);
    function Obr(typ : string; delka : byte) : TBitMap;
    procedure TiskniTecku(x, y : integer; typ : string);
    procedure TiskniNotu(x, y : integer; n : Tnota);
    procedure TiskniSkladbu(x, y : integer; s : Tskladba);
    function FormatSkladby(s : Tskladba) : Tskladba;
    procedure NactiObrazky(adr : string);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;




var
  Form1: TForm1;

  s : TSkladba;
  o : TObrazky;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);
  NactiObrazky('mladez\male\bmp\');
end;


procedure TForm1.Aktivace;
var BitMap : TBitMap;
    i : integer;
begin
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);

  Image1.Canvas.Pen.Color := clBlack;
  for i := 1 to 5 do begin
    Image1.Canvas.MoveTo(10, 10 + i*6);
    Image1.Canvas.LineTo(Image1.Width - 10, 10 + i*6);
  end;







end;

procedure TForm1.NactiSkladbu(adresa : string; var s : TSkladba);
var a, b : IXMLNode;
    i : integer;

begin


  Form1.XMLDocument1.LoadFromFile(adresa);
  a := Form1.XMLDocument1.DocumentElement;
  s.takt := strtoint(copy(a.Attributes['takt'], 1, 1));
  SetLength(s.noty, a.ChildNodes.Count);
  for i := 0 to a.ChildNodes.Count - 1 do begin
    b := a.ChildNodes.Nodes[i];


    if length(b.Attributes['delka']) > 2 then begin
      s.noty[i].delka := strtoint(copy(b.Attributes['delka'], 1, 1)) * 2 + 1;
    end
    else begin
      s.noty[i].delka := strtoint(b.Attributes['delka']) * 2;
    end;


    if b.NodeName = 'pomlka' then begin
      s.noty[i].vyska := 'p';
    end;
    if b.NodeName = 'nota' then begin
      s.noty[i].vyska := b.Attributes['vyska'];
    end;



  end;


end;

procedure TForm1.UpravaXY(var x, y : integer; typ : string; delka : byte);
begin
  if typ = 'tecka' then begin
    x := x + 10;
    case delka of
      2 : y := y - 4;
      4 : begin
            y := y - 4;
            x := x + 5;
          end;
    end;


  end else
  if typ = 'p' then begin
    case delka of
      1 : y := y + 13;
      2 : y := y + 8;
      4 : y := y + 15;
      8 : y := y + 12;




    end;
  end
  else begin
    y := y + 12;

    if length(typ) > 2 then begin
      y := y - 3;                     // krizek
    end;
    if UpperCase(typ) = typ then begin
      y := y + 3;                      // nahoru
    end;

    case upperCase(typ)[1] of
      'C' : y := y - 0;
      'D' : y := y - 3;
      'E' : y := y - 6;
      'F' : y := y - 9;
      'G' : y := y - 12;
      'A' : y := y - 15;
      'H' : y := y - 18;


    end;

    if delka = 8 then begin
      if UpperCase(typ) = typ then begin
        y := y + 18;
      end
      else begin
      y := y + 0;
      end;
    end;

  end;




end;
                                        {Vybr, jak obrzek pout}
function TForm1.Obr(typ : string; delka : byte) : TBitMap;
var posun : byte;
begin
  Obr := o[1];
  if typ = 'klic' then begin
    Obr := o[1];


  end else
  if typ = 'takt' then begin
    case delka of
      3 : Obr := o[20];
      4 : Obr := o[21];
      5 : Obr := o[22];


    end;
  end else
  if typ = 'p' then begin
    case delka of
      1 : Obr := o[16];
      2 : Obr := o[17];
      4 : Obr := o[18];
      8 : Obr := o[19];




    end;
  end
  else begin
    posun := 0;
    if length(typ) > 2 then begin
      posun := posun + 7;                      // krizek
    end;
    if UpperCase(typ) = typ then begin
      posun := posun + 3;                      // nahoru
    end;

    case delka of
      1 : Obr := o[3 + posun];
      2 : Obr := o[4 + posun];
      4 : Obr := o[5 + posun];
      8 : Obr := o[2];

    end;

  end;



end;

procedure TForm1.TiskniNotu(x, y : integer; n : TNota);
begin
   Image1.Canvas.Draw(x, y, Obr(n.vyska, n.delka));


end;

procedure TForm1.TiskniTecku(x, y : integer; typ : string);
begin
   y := y + 21;
   case upperCase(typ)[1] of
      'C' : y := y - 0;
      'D' : y := y - 3;
      'E' : y := y - 6;
      'F' : y := y - 9;
      'G' : y := y - 12;
      'A' : y := y - 15;
      'H' : y := y - 18;


    end;

    if UpperCase(typ) <> typ then begin
      y := y - 21;                      // nahoru
    end;


  Image1.Canvas.Brush.Color := clBlack;
  Image1.Canvas.Ellipse(x - 2, y - 2, x + 1, y + 1);




end;



procedure TForm1.TiskniSkladbu(x, y : integer; s : TSkladba);
var i : integer;
    nx, ny, delka : integer;
begin

  Image1.Canvas.Draw(x + 5, y, Obr('klic', 0));
  Image1.Canvas.Draw(x + 25, y + 7, Obr('takt', s.takt));

  for i := 0 to Length(s.noty) - 1 do begin
    nx := x + 45 + i * 20;
    ny := y;

    if s.noty[i].vyska = 'end' then begin
      Image1.Canvas.MoveTo(nx, ny + 6);
      Image1.Canvas.LineTo(nx, ny + 30);


    end
    else begin

      delka := s.noty[i].delka;
      if (delka * 2 mod 3) = 0 then begin
        delka := (delka * 2) div 3;
        UpravaXY(nx, ny, 'tecka', delka);
        TiskniTecku(nx, ny + 20, s.noty[i].vyska);

      end;

      nx := x + 45 + i * 20;
      ny := y;
      UpravaXY(nx, ny, s.noty[i].vyska, delka);
      Image1.Canvas.Draw(nx, ny, Obr(s.noty[i].vyska, delka));
      {Image1.Canvas.Brush.Color := clWhite;
      Image1.Canvas.TextOut(nx, ny + 30, inttostr(delka));
      Image1.Canvas.TextOut(nx, ny + 45, s.noty[i].vyska);   }
      if (ny < y) and (UpperCase(s.noty[i].vyska) < s.noty[i].vyska) then begin
        if length(s.noty[i].vyska) > 2 then begin
          nx := nx + 8;
        end;  
        Image1.Canvas.MoveTo(nx - 2, y);
        Image1.Canvas.LineTo(nx + 12, y);


      end;

      if s.noty[i].vyska = 'C' then begin
        if length(s.noty[i].vyska) > 2 then begin
          nx := nx + 8;
        end;  
        Image1.Canvas.MoveTo(nx - 2, y + 37);
        Image1.Canvas.LineTo(nx + 12, y + 37);


      end;
    end;




  end;


  for i := 1 to 5 do begin
    Image1.Canvas.MoveTo(10, 10 + i*6);
    Image1.Canvas.LineTo(790, 10 + i*6);
  end;

end;

function TForm1.FormatSkladby(s : Tskladba) : Tskladba;
var i : integer;
    pom, delka : integer;
    s2 : Tskladba;
    nota : Tnota;

    procedure pridejNotu(n : Tnota);
    begin
      if n.delka = 5 then begin
        n.delka := 4;
        pridejNotu(n);
        n.delka := 1;
      end;
      if n.delka = 7 then begin
        n.delka := 6;
        pridejNotu(n);
        n.delka := 1;
      end;
      if n.delka = 9 then begin
        n.delka := 8;
        pridejNotu(n);
        n.delka := 1;
      end;
      if n.delka = 10 then begin
        n.delka := 8;
        pridejNotu(n);
        n.delka := 2;
      end;
      SetLength(s2.noty, length(s2.noty) + 1);
      s2.noty[length(s2.noty) - 1] :=  n;

    end;

begin



  s2.takt := s.takt;
  SetLength(s2.noty, 0);
  pom := s.takt * 2;
  delka := 0;
  for i := 0 to Length(s.noty) - 1 do begin
    delka := s.noty[i].delka;
    while delka > 0 do begin

      pom := pom - delka;
      if pom <= 0 then begin

          nota.vyska := s.noty[i].vyska;
          nota.delka := delka + pom;
          pridejNotu(nota);
          delka := -pom;
          s.noty[i].delka := delka;
        

        nota.vyska := 'end';
        nota.delka := 0;
        pridejNotu(nota);
        pom := s.takt * 2;
      end
      else begin
        pridejNotu(s.noty[i]);
        delka := 0;
      end;
    end;



  end;


  FormatSkladby := s2;

end;

procedure TForm1.NactiObrazky(adr : string);
var i : integer;
begin
  for i := 1 to 22 do begin
    o[i] := TBitMap.Create;
  end;



  o[1].LoadFromFile(adr + 'klic.bmp');
  o[2].LoadFromFile(adr + 'nota_4.bmp');
  o[3].LoadFromFile(adr + 'nota_dolu_0.bmp');
  o[4].LoadFromFile(adr + 'nota_dolu_1.bmp');
  o[5].LoadFromFile(adr + 'nota_dolu_2.bmp');
  o[6].LoadFromFile(adr + 'nota_nahoru_0.bmp');
  o[7].LoadFromFile(adr + 'nota_nahoru_1.bmp');
  o[8].LoadFromFile(adr + 'nota_nahoru_2.bmp');

  o[9].LoadFromFile(adr + 'nota_krizek_4.bmp');
  o[10].LoadFromFile(adr + 'nota_krizek_dolu_0.bmp');
  o[11].LoadFromFile(adr + 'nota_krizek_dolu_1.bmp');
  o[12].LoadFromFile(adr + 'nota_krizek_dolu_2.bmp');
  o[13].LoadFromFile(adr + 'nota_krizek_nahoru_0.bmp');
  o[14].LoadFromFile(adr + 'nota_krizek_nahoru_1.bmp');
  o[15].LoadFromFile(adr + 'nota_krizek_nahoru_2.bmp');

  o[16].LoadFromFile(adr + 'pomlka_0.bmp');
  o[17].LoadFromFile(adr + 'pomlka_1.bmp');
  o[18].LoadFromFile(adr + 'pomlka_2.bmp');
  o[19].LoadFromFile(adr + 'pomlka_4.bmp');
  o[20].LoadFromFile(adr + 'takt_3.bmp');
  o[21].LoadFromFile(adr + 'takt_4.bmp');
  o[22].LoadFromFile(adr + 'takt_5.bmp');

  for i := 1 to 22 do begin
    o[i].TransparentColor := clWhite;
    o[i].Transparent := true;
  end;

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Aktivace;
  NactiSkladbu('mladez\' + Edit1.Text, s);
  s := FormatSkladby(s);
  TiskniSkladbu(10, 10, s);

end;

end.
